//Uzduotis N18 su papildymais.

Programa dirba su dvipusiu sarasu:
1.Sukuria sarasa;
2.Sukuria tuscia sarasa;
3.Patikrina ar sarasas tuscias;
4.Suskaiciuoja saraso elementus;
5.Gauna n-tojo saraso elemento duomenis;
6.Panaikina n-taji saraso elementa;
7.Isveda saraso elementus;
8.Naikina sarasa. */

#include <stdio.h>
#include <stdlib.h>

struct el {
       struct el *kitas;
       int duom;
       struct el *atgal;
       };

void sukurti           (struct el **, struct el ** );
void sukurti_tuscia    (struct el **, struct el ** );
void spausdinti        (struct el *);
void ar_tuscias        (struct el *);
int skaiciuoti         (struct el *);
int parodyti_n         (struct el *);
int istrinti_n         (struct el **, struct el **  );
void naikinti          (struct el **, struct el ** );


int main ()
{ 
    struct el *pradzia=NULL, *pabaiga=NULL;
     
sukurti_tuscia    (&pradzia, &pabaiga);
sukurti           (&pradzia, &pabaiga);
ar_tuscias        (pradzia); 
skaiciuoti        (pradzia);                    spausdinti        (pradzia);
parodyti_n        (pradzia);
istrinti_n        (&pradzia, &pabaiga);         spausdinti        (pradzia);
naikinti          (&pradzia, &pabaiga);         spausdinti        (pradzia);
ar_tuscias        (pradzia);
  
int d;
scanf("%d", &d);  //kad nepanaikintu .exe lango
printf ("%d", d);

return 0;
}

void sukurti(struct el **pr, struct el **pab)
{struct el *elem;
int x;

     *pr=NULL;
     *pab=NULL;
     puts("Kuriame sarasa. Iveskite sveikus skaicius.");
     puts("Noredami baigti, iveskite 0.");
     scanf ("%d", &x);
     while (x!=0)
     {
          if (*pr==NULL)
          {
               elem=(struct el *) malloc(sizeof (struct el));
               elem->duom=x;
               elem->kitas=NULL;
               elem->atgal=NULL;
               *pr=elem;
               *pab=elem;
               }
          else
          {
               elem=(struct el *) malloc(sizeof (struct el));
               elem->duom=x;
               elem->kitas=NULL;
               (*pab)->kitas=elem;
               elem->atgal=*pab;
               *pab=elem;
               }
               scanf ("%d", &x);
               }
     puts("Sarasas sekmingai sukurtas.\n");
}

void sukurti_tuscia (  struct el **pr, struct el **pab)
{
     *pr=NULL;
     *pab=NULL;
}

void spausdinti (struct el *elem)
{
     puts("Spausdiname sarasa.\n");
     while (elem!=NULL)
     {
          printf("%d \n", elem->duom);
          elem=elem->kitas;
          }
}

void naikinti (struct el **pr, struct el **pab)
{ struct el *g;

     puts("Naikiname sarasa nuo galo.");
     while ((*pab)->atgal!=NULL)
     {
          *pab=(*pab)->atgal;
          g=(*pab)->kitas;
          free (g);
      }
      if ((*pab)->atgal==NULL)
      {free (*pab);
      *pr=NULL;
      *pab=NULL;}
} 

void ar_tuscias (struct el *pr)
{
     if (pr==NULL) puts ("Sarasas yra tuscias.\n");
     else puts("Sarasas yra netuscias. \n");
}

int skaiciuoti (struct el *elem)
{ int ki=0;  
	while (elem!=NULL)
	   {
		ki++;
		elem = elem->kitas;
    }
	printf ("Elementu sarase yra: %d \n", ki);
	return ki;
}


int parodyti_n (struct el *elem)
{ int ki=0, n;

        puts("Iveskite elemento nr, kurio reiksme norite paziureti.");
        scanf ("%d", &n);
	while (elem!=NULL)
	   {
		ki++;
                if (ki==n) 
                   {
                        printf ("Sio elemento reiksme yra: %d\n", elem->duom);
                        return elem->duom;
                        }
                        elem=elem->kitas;
                        }
	if (ki!=n) puts ("Klaida.Tokio elemento sarase nera.!\n");
	return 0;

}



int istrinti_n (struct el **pr, struct el **pab)
{  int ki=0, n;
     struct el *elem=*pr;
     puts ("Iveskite elemento nr, kuri norite panaikinti.");
     scanf ("%d", &n);
	while (elem!=NULL) 
	   {
		ki++;
                if ((ki==n) && (ki!=1) && (elem->kitas!=NULL)) 
                   {
                        printf ("Trinamo elemento reiksme yra: %d\n", elem->duom);
                        elem->kitas->atgal=elem->atgal;
                        elem->atgal->kitas=elem->kitas;
                        free (elem);
                        return 1;
                        }
                if ((ki==n) && (ki==1))     //jei pirmas elementas
                  {
                    printf ("Trinamo elemento reiksme yra: %d\n", elem->duom);
                    *pr=(*pr)->kitas;
                    (*pr)->atgal=NULL;
                    free (elem);
                    return 1;
                    }
                if ((ki==n) && (elem->kitas==NULL))  //jei paskutinis elementas
                   {
                     printf ("Trinamo elemento reiksme yra: %d\n", elem->duom);
                     *pab=(*pab)->atgal;
                     (*pab)->kitas=NULL;
                     free(elem);
                     return 1;
                     }
                elem=elem->kitas;
                }
	if (ki!=n) puts ("Klaida.Tokio elemento sarase nera!\n");
	return 0;
}
